import { Base, Type, Point } from "igniteui-react-core/ES2015/type";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-react-core/ES2015/IFastItemColumn$1";
import { Rect } from "igniteui-react-core/ES2015/Rect";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { CategoryMode } from "./CategoryMode";
import { FramePreparer } from "./FramePreparer";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { List$1 } from "igniteui-react-core/ES2015/List$1";
import { ISupportsMarkers } from "./ISupportsMarkers";
import { IProvidesViewport } from "./IProvidesViewport";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { CategoryFrame } from "./CategoryFrame";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { PreparationParams } from "./PreparationParams";
import { Frame } from "./Frame";
import { ICategoryScaler } from "./ICategoryScaler";
import { ValuesHolder } from "./ValuesHolder";
import { NumericAxisBase } from "./NumericAxisBase";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { ICategorySeriesInteractionManager } from "./ICategorySeriesInteractionManager";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { AssigningCategoryMarkerStyleEventArgs } from "./AssigningCategoryMarkerStyleEventArgs";
import { SeriesComponentsForView } from "./SeriesComponentsForView";
import { Pool$1 } from "igniteui-react-core/ES2015/Pool$1";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { RenderSurface } from "./RenderSurface";
import { Clipper } from "igniteui-react-core/ES2015/Clipper";
/**
 * @hidden
 */
export declare class CategoryBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected c: CategorySeriesView;
    constructor(a: CategorySeriesView);
    e: number;
    f: number;
    d: number;
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    g(a: number): void;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class CategoryFramePreparerBase extends FramePreparer {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    g: IBucketizer;
    h: IIsCategoryBased;
    protected abstract l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    m: boolean;
    private i;
    r(a: ICategoryScaler, b: Rect, c: Rect, d: Rect): number;
    private s;
    d(a: Frame, b: SeriesView): void;
    protected v(a: CategoryFrame, b: SeriesView): void;
    private o;
    protected readonly q: List$1<number[]>;
    private p;
    private n;
    protected t(a: PreparationParams, b: ValuesHolder, c: number, d: boolean, e: boolean): number;
    protected k(): boolean;
    protected abstract z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected abstract u(a: ValuesHolder, b: number, c: boolean): void;
    protected abstract e(a: number, b: ValuesHolder): number[];
    protected f(a: PreparationParams, b: number, c: ValuesHolder, d: number, e: boolean, f: number[], g: number): {
        ret: number[];
        p1?: number;
        p4: boolean;
        p5: number[];
    };
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected abstract x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected abstract j(a: PreparationParams): ValuesHolder;
}
/**
 * @hidden
 */
export declare class CategoryFramePreparer extends CategoryFramePreparerBase {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    protected aa: IHasCategoryTrendline;
    protected ab: IHasSingleValueCategory;
    protected l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    protected j(a: PreparationParams): ValuesHolder;
    protected x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected u(a: ValuesHolder, b: number, c: boolean): void;
    protected e(a: number, b: ValuesHolder): number[];
}
/**
 * @hidden
 */
export declare abstract class CategorySeries extends MarkerSeries implements IHasCategoryModePreference, ISupportsErrorBars {
    static $t: Type;
    m4: CategoryFramePreparer;
    protected bf(): SeriesView;
    m8: CategorySeriesView;
    private nh;
    readonly ni: ICategorySeriesInteractionManager;
    ch(a: List$1<SeriesPointOfInterest>, b: boolean, c: number): boolean;
    private n3;
    im(a: SeriesView): void;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    readonly categoryAxis: CategoryAxisBase;
    mz(): CategoryAxisBase;
    nj(): NumericAxisBase;
    protected get_cl(): boolean;
    constructor();
    ac(): void;
    nq: boolean;
    np: boolean;
    protected nl: boolean;
    protected nk: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    assigningCategoryMarkerStyle: (sender: any, args: AssigningCategoryMarkerStyleEventArgs) => void;
    protected ns(): boolean;
    protected nt(): boolean;
    protected og(a: AssigningCategoryStyleEventArgs): void;
    protected of(a: AssigningCategoryMarkerStyleEventArgs): void;
    mt(a: number, b: number): any[];
    hp(a: boolean, b: SeriesView): void;
    a8(): SeriesComponentsForView;
    h4(): void;
    nv: boolean;
    protected jm(a: Rect, b: Rect): void;
    na: CategoryTransitionInMode;
    nr: boolean;
    protected jl(a: Rect, b: Rect): void;
    protected is(a: any, b: string, c: any, d: any): void;
    protected nn(): boolean;
    protected nm(): boolean;
    ny(a: Point): number;
    protected get_c1(): boolean;
    ap(): CategoryAxisBase;
    e7(a: Point): number;
    abstract getOffsetValue(): number;
    abstract getCategoryWidth(): number;
    fm(a: Point): any;
    e5(a: Point): number;
    d8(a: Point): number;
    private nf;
    private ng;
    protected get_no(): boolean;
    protected readonly no: boolean;
    au(a: any, b: Point): HighlightingInfo;
    protected get_cv(): boolean;
    at(a: any, b: Point): HighlightingInfo;
    protected nx(): List$1<Marker>;
    protected ne(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected nd(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected nc(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    m1: CategoryFrame;
    m3: CategoryFrame;
    m0: CategoryFrame;
    m2: CategoryFrame;
    protected m7: CategorySeriesRenderManager;
    protected oc(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    protected od(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    dv(a: Rect, b: Rect, c: SeriesView): boolean;
    private nw;
    protected db(): boolean;
    protected m9(): CategoryTransitionInMode;
    nb: CategoryTransitionSourceFramePreparer;
    protected hq(): void;
    i7(a: boolean): void;
    protected bo(): TransitionInSpeedType;
    protected nz(): number;
    n2(): number;
    readonly GetErrorBarsXAxis: Axis;
    readonly GetErrorBarsYAxis: Axis;
    ob(a: CategorySeriesView, b: CategoryFrame): void;
    oh(a: CategoryFrame, b: CategorySeriesView): void;
    oe(a: CategoryFrame, b: CategorySeriesView): void;
    n0(a: SeriesView): number;
    n1(a: SeriesView): number;
    oa(a: SeriesView): void;
    i8(a: Rect, b: RenderSurface): void;
    oi(): void;
    abstract fetchXAxis(): Axis;
    abstract fetchYAxis(): Axis;
    abstract nu(): boolean;
    m5(a: CategorySeriesView): CategoryFramePreparer;
    am(a: Axis): Axis;
    ag(): Axis[];
    static mu(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CategorySeriesView extends MarkerSeriesView implements ISupportsMarkers {
    static $t: Type;
    cp: CategorySeries;
    cs: number;
    cr(a: CategoryFrame): boolean;
    cu(a: CategoryFrame): void;
    constructor(a: CategorySeries);
    updateMarkerTemplate(a: number, b: number, c: number): void;
    cn: CategoryBucketCalculator;
    co(): CategoryBucketCalculator;
    cq: Pool$1<Marker>;
    readonly shouldDisplayMarkers: boolean;
    updateMarkerCount(a: number): void;
    cc(a: (arg1: Marker) => void): void;
    ct(): void;
}
